/***************************************************************
 * Name:      wx016Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-01-04
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX016MAIN_H
#define WX016MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx/headerctrl.h"

#include "wx016App.h"

class MiHeaderCtrl: public wxHeaderCtrlSimple {
public:
    MiHeaderCtrl() : wxHeaderCtrlSimple() {}
    MiHeaderCtrl(wxWindow *parent,
               wxWindowID winid = wxID_ANY,
               const wxPoint& pos = wxDefaultPosition,
               const wxSize& size = wxDefaultSize,
               long style = wxHD_DEFAULT_STYLE,
               const wxString& name = wxASCII_STR(wxHeaderCtrlNameStr)) :
            wxHeaderCtrlSimple(parent, winid, pos, size, style, name) {}
    void UpdateColumnVisibility(unsigned int idx, bool show) {
        unsigned int c=0;
        for(unsigned int i=0; i<GetColumnCount(); i++) {
            if(GetColumn(i).IsShown()) c++;
        }
        if(c>1 || show) ShowColumn(idx, show);
    }
    void UpdateColumnsOrder(const wxArrayInt& order) {
        SetColumnsOrder(order);
    }
};

class wx016Frame: public wxFrame
{
    public:
        wx016Frame(wxFrame *frame, const wxString& title);
        ~wx016Frame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout,
            idHeader
        };
        wxSizer *m_sizerHeader;
        MiHeaderCtrl* headerCtrl;
        void InsertaColumna(const wxString& etq, int ancho, const wxBitmapBundle& bm);
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};

#endif // WX016MAIN_H
